const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Service_pricesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_prices = await db.service_prices.create(
            {
                id: data.id || undefined,
        
        service_name: data.service_name
        ||
        null
            ,
            
        min_price: data.min_price
        ||
        null
            ,
            
        max_price: data.max_price
        ||
        null
            ,
            
        typical_price: data.typical_price
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        created_at_ts: data.created_at_ts
        ||
        null
            ,
            
        updated_at_ts: data.updated_at_ts
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await service_prices.setBusiness( data.business || null, {
            transaction,
        });
        

        

        

        return service_prices;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const service_pricesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                service_name: item.service_name
            ||
            null
            ,
            
                min_price: item.min_price
            ||
            null
            ,
            
                max_price: item.max_price
            ||
            null
            ,
            
                typical_price: item.typical_price
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                created_at_ts: item.created_at_ts
            ||
            null
            ,
            
                updated_at_ts: item.updated_at_ts
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const service_prices = await db.service_prices.bulkCreate(service_pricesData, { transaction });

        // For each item created, replace relation files
        

        return service_prices;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const service_prices = await db.service_prices.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.service_name !== undefined) updatePayload.service_name = data.service_name;
        
        
        if (data.min_price !== undefined) updatePayload.min_price = data.min_price;
        
        
        if (data.max_price !== undefined) updatePayload.max_price = data.max_price;
        
        
        if (data.typical_price !== undefined) updatePayload.typical_price = data.typical_price;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.created_at_ts !== undefined) updatePayload.created_at_ts = data.created_at_ts;
        
        
        if (data.updated_at_ts !== undefined) updatePayload.updated_at_ts = data.updated_at_ts;
        
        
        updatePayload.updatedById = currentUser.id;

        await service_prices.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await service_prices.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        

        
        

        

        return service_prices;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const service_prices = await db.service_prices.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of service_prices) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of service_prices) {
                await record.destroy({transaction});
            }
        });


        return service_prices;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const service_prices = await db.service_prices.findByPk(id, options);

        await service_prices.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await service_prices.destroy({
            transaction
        });

        return service_prices;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const service_prices = await db.service_prices.findOne(
            { where },
            { transaction },
        );

        if (!service_prices) {
            return service_prices;
        }

        const output = service_prices.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await service_prices.getBusiness({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    const currentUser = options?.currentUser;

    // Data Isolation
    if (currentUser && currentUser.app_role) {
        const roleName = currentUser.app_role.name;
        if (roleName === 'Verified Business Owner') {
            if (currentUser.businessId) {
                where.businessId = currentUser.businessId;
            } else {
                where['$business.owner_userId$'] = currentUser.id;
            }
        }
    }

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.service_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_prices',
                        'service_name',
                        filter.service_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'service_prices',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.min_priceRange) {
                const [start, end] = filter.min_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    min_price: {
                    ...where.min_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    min_price: {
                    ...where.min_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.max_priceRange) {
                const [start, end] = filter.max_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    max_price: {
                    ...where.max_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    max_price: {
                    ...where.max_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.typical_priceRange) {
                const [start, end] = filter.typical_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    typical_price: {
                    ...where.typical_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    typical_price: {
                    ...where.typical_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.created_at_tsRange) {
                const [start, end] = filter.created_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.updated_at_tsRange) {
                const [start, end] = filter.updated_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    updated_at_ts: {
                    ...where.updated_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    updated_at_ts: {
                    ...where.updated_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.service_prices.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'service_prices',
                        'service_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.service_prices.findAll({
            attributes: [ 'id', 'service_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['service_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.service_name,
        }));
    }

    
};